<?php
  defined('ABSPATH') or die('');

  define("POPSHOPS_BASE",str_replace("/wp-admin", "" , getcwd()));
  $imagedir = POPSHOPS_BASE."/wp-content/plugins/popshops/images/";
  $add_style = 'none';
  $add_style_toggle = 'block';
  
  PopShopsHTML::javascript();
  PopShopsHTML::styles();

  if( $_POST != null )
  {
    wp_cache_flush();

    switch( $_POST['task'] ) {
	    case 'login':
				PopShopsHtml::login();
				break;
			case 'signup':
				PopShopsHtml::signup();
				break;
			case 'edit_shop_options':
			  $shop = PopShops::find_shop( $_POST['id'] );
			  PopShopsHtml::edit_shop( $shop, 'edit_options' );
				break;
			case 'add_shop': 
  			PopShopsHtml::edit_shop(false,'','add_shop');
  			break;
			case 'api_key':
			  PopShopsHtml::api_key();
			  break;
			case 'activate_key':
			  $key = PopShops::activate_key();
			  if ( $key != 'false' ) {
			    PopShopsHTML::index('PopShops API key successfully found and saved<br/>NOTE: You may need to clear your browser\'s cache in order for the Product Popper to appear correctly.');
			  } else {
			    PopShopsHtml::login("You're user/name password wasn't right.  Give it another try.");
			  }
			  break;
      case 'save_key':
 				PopShops::save_api_key($_POST['key']); 
				PopShopsHTML::index('PopShops API key successfully saved.');
				break;
			case 'successful_signup':
			  PopShops::save_api_key($_POST['key']);
			  PopShopsHTML::successful_signup($_POST['flash']);
			  break;
		  case 'save_shop': 
		    if ($_POST['popshops_shop']['shop_id']) {
			    PopShops::save_shop($_POST['popshops_shop']);
				  $flash = 'Shop published successfully.';
			  } 
				PopShopsHtml::index($flash);
			  break;
			case 'remove_shop': 
			  if ($_POST['id']) {
					PopShops::destroy_shop($_POST['id']);        
					$flash = 'Shop successfully removed.';
				}
				PopShopsHtml::index($flash);
				break;
			default:
			  PopShopsHtml::index();
			  break;
    }
  } else { 
	  PopShopsHtml::index();
  }
  
  class PopShopsMenu {
  	function index() {
  		PopShopsMenu::start_menu();
  		PopShopsMenu::add_shop_link();
  		PopShopsMenu::spacer();
  		PopShopsMenu::api_key_link();
  		PopShopsMenu::end_menu();
  	}

    function edit() { 
       PopShopsMenu::start_menu();
       PopShopsMenu::cancel_link();
       PopShopsMenu::end_menu();
    }

  	function start_menu() { ?><div><?php }

  	function end_menu() { ?></div><?php }

  	function spacer() { ?>&nbsp;|&nbsp;<?php	}

  	function cancel_link() {
  	  PopShopsHelpers::form_link('Cancel and go back', array('task' => 'index'));
  	}

    function add_shop_link() { 
  	  PopShopsHelpers::form_link('Add a shop to your sidebar, footer, and more&hellip;',array('task' => 'add_shop'));
    }

    function create_shop_link() {
  	  PopShopsHelpers::form_link('Create a new shop',array('task' => 'create_shop'),array('style' => 'font-weight:bold;font-size:14px;'));
    }
    
    function api_key_link() {
      PopShopsHelpers::form_link('API Key', array('task' => 'api_key'));
    }
  }
  
  class PopShopsHelpers {
    function form_link($label, $form_options = '', $options = '') { 
  	  $form_options_html = '';
  		$options_html = '';

  		if (is_array($form_options)) {
       	foreach($form_options as $attribute => $value) {
  	    	$form_options_html .= "var $attribute = document.createElement('input');"
  				. "$attribute.type='hidden'; "
  				. "$attribute.name='$attribute';"
  				. "$attribute.value='$value';"
  				. "f.appendChild($attribute);";
  			}
  		}

  		if (is_array($options)) {
  			foreach ($options as $attribute => $value) {
  		   	$options_html.=$attribute.='="'.$value.'" ';
  			}
  		}
  	?>
  	<a href="#" onclick="var f = document.createElement('form'); this.parentNode.appendChild(f); f.method = 'POST'; <?php echo $form_options_html ?> f.submit();" <?php echo $options_html ?>><?php echo $label ?></a>
  	<?php
    }

    function flash($message) { ?>
  	<div id="message" class="updated fade"><p><strong><?php echo $message ?></strong></p></div>
  	<?php
    }
    
    function javascript($name,$plugin_root=false) { ?>
  	  <script type="text/javascript" src="http://<?php echo POPSHOPS_URL ?>/javascripts/plugins/<?php echo ( ( $plugin_root == false ) ? 'wordpress/' . $name . POPSHOPS_VERSION : $name ) ?>.js"></script>
  	<?php
  	}
  	
  	function stylesheet($name) { ?>
      <link rel="stylesheet" href="http://<?php echo POPSHOPS_URL ?>/stylesheets/plugins/wordpress/<?php echo $name ?><?php echo POPSHOPS_VERSION ?>.css" type="text/css" />
    <?php
    }
  	
  }
  
  class PopShopsHtml {
    function header() { ?>
  		<div class="wrap" id="popshops_wrap">
  			<h2>PopShops Options</h2>
  	<?php
  	}

  	function footer() { ?></div><?php }
  	
  	function successful_signup($flash = '') { ?>
  	  <script type="text/javascript">
  	    window.parent.PopShops.save_api_key('<?php echo $flash ?>');
  		</script>
  	<?php
  	}
  	    
    function welcome() { 
      if ($flash != '') PopShopsHelpers::flash($flash);
  		PopShopsHTML::header();
  		?>
  		<table width="100%">
      	<tr>
      		<td style="vertical-align:top;padding:0 25px;">
      			<h3>About this plugin</h3>
      			<p>
      				Now you can add products to you blog by searching through over 20 million
      				commission-earning products from over 1,000 merchants. You will need to create 
      				an account with PopShops in order to activate a PopShops API Key that your 
      				WordPress installation will use to access the ShopBuilder service.
      			</p>
      			<h3>Add an affiliate product directly into a post</h3>
      			<p>
      			  Use the Product Popper to add affiliate product links into a post you're writing.
      			  Click on the Product Popper <img src="../wp-content/plugins/popshops/images/popshops.gif" style="vertical-align:middle;"/> button on your WYSIWYG editor.
      			</p>
      			<p>
      			  <img src="../wp-content/plugins/popshops/images/wysiwyg.gif" alt="Product Popper" />
      			</p>
      		  <h3>Add a shop to your sidebar, footer, and more&hellip;</h3>
      		  <p>
      		    You can also add shops created at <a href="http://www.popshops.com/" target="_blank">PopShops.com</a> 
      		    directly into your sidebar, footer, or after a post.<br/>
      		    <br/>
      		    Simply choose the shop you want from a dropdown showing all your shops, pick where you would like
      		    the shop to appear in your blog and publish.
      		  </p>
      		  <hr/>
      			<p>
      				Please take a moment to <a href="../wp-content/plugins/popshops/READ_ME_FIRST.htm" target="blank">read more about how this plugin works and review our
      				licensing agreement and terms of use</a>.  You will also have a
      				chance to review those terms when you create an account.
      			</p>
      		</td>
      		<td style="vertical-align:top;">
      		  <?php echo PopShops::image('logo.gif','PopShops') ?>
      			<p style="padding-bottom:15px;">
      			  <a href="http://<?php echo POPSHOPS_URL ?>/signup" target="popshops_top" style="font-weight:bold;font-size:18px;line-height:20px;">Create an account to continue</a>
      			</p>
      			<p style="font-size:11px;">
      				<strong>Already have a PopShops account?</strong><br/> <?php echo PopShopsHelpers::form_link('Login to activate your PopShops API Key', array('task' => 'login')) ?>
      			</p>
      		</td>
      	</tr>
      </table>
  		<?php
  	  PopShopsHtml::footer();
  	}
  	
    function index($flash = '') { 
      if (PopShops::find_api_key()) {
        $shops = PopShops::find_shops_with_names();
        if ($flash != '') PopShopsHelpers::flash($flash);
        PopShopsHtml::header();
        PopShopsMenu::index();
        ?>
          <h3>WordPress Shop List</h3>
          <p>
            Below are the shops you have added to this blog.  This list does <strong>not</strong> include
            products added to your posts using the Product Popper.
          </p>
          <p style="margin-bottom:3px;">To manage (edit, delete, rename, etc.) your shops, <a href="http://www.popshops.com" target="_blank">log in to PopShops.com</a></p>
  				<table id="popshops_list_of_shops" style="display:<?php echo $table_display ?>">
  	        <tr>
  	          <th class="left">Shop name</th>
  	          <th class="center" style="width:150px;">Location</th>
  	          <th class="right" colspan="3" style="width:190px;">Action</th>
  	        </tr>
  	        <?php
  	        if (sizeof($shops) == 0) { ?>
  	        <tr>
  	          <td colspan="3" style="text-align:center;">
  	            <p>You have no shops in this WordPress blog. <?php echo PopShopsHelpers::form_link('Add a shop',array('task' => 'add_shop')); ?></p>
  	          </td>
  	        </tr>
  	        <?php
              } else {
              $odd_or_even = 0;
  	        	foreach ($shops as $shop) { 
  	        	  $odd_or_even = 1 - $odd_or_even;
  	        ?>
  	        <tr class="alternate<?php echo $odd_or_even ?>" onclick="">
  	          <td>
  	            <?php echo $shop->shop_name ?>
  	          </td>
  	          <td><?php 
  	              switch($shop->location) {
  	                case 'page': 
  	                  $page = PopShops::find_page($shop->page_id);
  	                  echo "Page: ".PopShops::h($page->post_title); 
  	                  break;
  	                case 'footer': echo 'Only in the footer'; break;
  	                case 'post': 
  	                  if ($shop->post_id) {
  	                    $post = PopShops::find_post($shop->post_id);
  	                    echo "Post: ".PopShops::h($post->post_title);
  	                  } else {
  	                    echo 'After each post (randomly)';
  	                  }
  	                  break; 
  	                case 'sidebar': echo 'Only in the sidebar'; break;
  	              } ?></td>
  	          <td align="center">
  	            <a href="http://<?php echo POPSHOPS_URL ?>/tools/shopbuilder/<?php echo $shop->shop_id ?>" target="popshops_top">Edit products</a>
  	          </td>
  	          <td align="center">
  	            <?php
  	              if ($shop->post_id) {
  	                ?>
  	                <a href="../wp-admin/post.php?action=edit&post=<?php echo $shop->post_id ?>">Edit Post</a>
  	                <?php
  	              } else {
  	                ?>
  	                <a href="#" onclick="var f = document.createElement('form'); this.parentNode.appendChild(f); f.method = 'POST'; var task = document.createElement('input'); task.type = 'hidden'; task.name = 'task'; task.value = 'edit_shop_options'; var id = document.createElement('input'); id.type = 'hidden'; id.name = 'id'; id.value = '<?php echo $shop->id ?>'; f.appendChild(task); f.appendChild(id); f.submit(); ">Edit options</a>  
  	                <?php
  	              }
  	            ?>
  	          </td>
  	          <td align="center">
  	          	<a href="#" onclick="if(confirm('Are you sure you want to remove this shop from your blog?\n(The shop will still be available in your list of existing PopShops shops.)')){var f = document.createElement('form'); this.parentNode.appendChild(f); f.method = 'POST'; var task = document.createElement('input'); task.type='hidden'; task.name = 'task'; task.value = 'remove_shop'; f.appendChild(task); var id = document.createElement('input'); id.value = '<?php echo $shop->id ?>'; id.name = 'id'; id.type='hidden'; f.appendChild(id); f.submit();}">Remove</a>
  	          </td>
  	        </tr>
  	        <?php 
  	            } 
  	          }
  	        ?>
  	      </table>
  		<?php
        PopShopsHtml::footer();
      } else {
  			PopShopsHtml::welcome();
  		}
    }
    
    function edit_shop($shop = '', $action = '' ) { 
  		global $imagedir;
  		$label      = $new ? 'Add' : 'Edit';
  	  $location   = ($shop != '') ? $shop->location : '';
  	  $wp_shop_id = ($shop != '') ? $shop->id 			: '';
  	  $popshops_shop_id = ($shop != '') ? $shop->shop_id 	: '';
  	  $page_id 	  = ($shop != '') ? $shop->page_id 	: '';
  	  PopShopsHtml::header();
  	  if ($new == true) $popshops_shop_id = $wp_shop_id = 'latest';
  	  PopShopsMenu::edit();
  		?>

  		<div class="wrap">
  	    <form method="post">
          <input type="hidden" name="task" value="save_shop" />
          <input type="hidden" name="popshops_shop[id]" id="popshops_shop_id" value="<?php echo $wp_shop_id ?>" />
          <h3><?php echo $label ?> shop settings</h3>
          <p>
            Available PopShops: 
            <?php echo PopShops::shop_dropdown($popshops_shop_id); ?>
          </p>
          <p>
            Where would you like your shop appear?&nbsp;&nbsp;
            <select name="popshops_shop[location]" id="popshops_shop_location" onchange="PopShops.toggle_sidebar(this)">
              <option value="">-- Choose One --</option>
              <option value="page"<?php echo ($location == 'page') ? ' selected="selected"' : '' ?>>
  							On a static page
  						</option>
              <option value="footer"<?php echo ($location == 'footer') ? ' selected="selected"' : '' ?>>
  							Only in the footer
  						</option>
              <option value="sidebar"<?php echo ($location == 'sidebar') ? ' selected="selected"' : '' ?>>
  							Only in the sidebar
  						</option>
              <option value="post"<?php echo ($location == 'post') ? ' selected="selected"' : '' ?>>
  							After each post (randomly)
  						</option>
            </select>
            <div id="popshops_sidebar_option"<?php echo (($location == 'page') || ($location == '')) ? '' : 'style="display:none;"' ?>>
                <p style="border-top:1px solid #ccc;padding-top:15px;">
                  What page do you want it on?&nbsp;&nbsp;  
                  <select name="popshops_shop[page_id]" id="popshops_shop_page_id">
                  <?php
                    $pages = PopShops::find_all_pages();
                    if ($pages) {
                      foreach ($pages as $page) { ?>
                    <option value="<?php echo $page->ID ?>"<?php echo ($page_id == $page->ID) ? ' selected="selected"' : '' ?>>
  										<?php echo PopShops::h($page->post_title) ?>
  									</option>
                  <?php
                      }
                    } ?>
                  </select>
                </p>
            </div>
          <p class="submit">
            <?php echo PopShopsHelpers::form_link('Cancel','') ?> or 
            <input type="submit" value="Publish shop &raquo;" />
          </p>
        </form>	
      </div>
  		<?php
  		PopShopsHtml::footer();
  	}

    function login($flash='') { 
  		PopShopsHtml::header(); 
  		PopShopsHelpers::form_link( 'Cancel and go back', array( 'task' => 'index' ) );
  		PopShopsHelpers::javascript( 'sha1', true);
  		PopShopsHelpers::stylesheet( 'login' );
  		?>
  		<table style="width:100%" align="center">
        <tr>
          <td style="padding-right:25px;">
            <?php echo PopShops::image( 'logo.gif', 'PopShops') ?>
            <?php if ($flash == '') { 
              PopShopsHelpers::flash("Login to your PopShops Account and we'll activate your API key.");
             } else {
               PopShopsHelpers::flash($flash);
             } ?>
          </td>
          <td style="vertical-align:bottom;">
            <div id="login-form">
              <form method="post" onsubmit="this.user_password.value = hex_sha1(this.user_password.value);">
                <input type="hidden" name="task" value="activate_key" />
              	<p>
              	  <label for="user_email">E-mail</label><br/>
              	  <input type="text" name="user_email" id="user_email" class="text" />
                </p>
              	<p>
              	  <label for="user_password">Password</label><br/>
              		<input type="password" name="user_password" id="user_password" class="text" />
                </p>
              	<p class="submit"><input type="submit" value="Sign In" /></p>	
              </form>
            </div>
          </td>
        </tr>
      </table>
  	<?php
  	  PopShopsHtml::footer();
  	}
  	
  	function no_iframes() { ?>
  		<p>Your browser unfortunately doesn't support iframes.  In order 
  		to use this plugin you will need a browser capable of using 
  		iframes, such as Internet Explorer 6 or Firefox.</p>
  	<?php 
  	}
  	
  	function api_key() { 
  		PopShopsHtml::header();
  		PopShopsMenu::cancel_link();
  		?>
  		<h3>PopShops API Key</h3>
      <p>The API key enables your WordPress administration to remotely call the PopShops ShopBuilder services.</p>
      <form method="post">
  			<input type="hidden" name="task" value="save_key" />
  			<p>
  				<strong>API Key:</strong>
  				<input type="text" name="key" value="<?php echo POPSHOPS_API_KEY ?>" style="width:550px;" />&nbsp;&nbsp;
  				<p class="submit"><input type="submit" value="Save key" /></p>
  			</p>
  		</form>
      <p>
  			Note: If you do not have your remote access key you can <a href="http://<?php echo POPSHOPS_URL ?>/affiliates/remote_access_key" target="popshops_top">find it at 
  			PopShops.com</a>.  Just login and click on 'Your Account'.  Copy the 
  			remote access key and then add it to your WordPress.
  		</p>
  		<?php
  		PopShopsHtml::footer();
  	}
  	
  	function javascript() { ?>
      <script type='text/javascript' src='../wp-includes/js/prototype.js'></script>
  	  <script type="text/javascript">
      //<![CDATA[
        var PopShops = {
      		toggle_sidebar:function(select) {
            $('popshops_sidebar_option').style.display = (select.value == 'page') ? 'block' : 'none';
          },
          toggle_image_loader:function(select) {
            $('custom_image').style.display = (select.value == 'custom') ? 'block' : 'none';      
          },
      		save_api_key:function(flash_msg) {
      			var f = document.createElement('form');
      			f.method = 'POST';

      			var input = document.createElement('input');
      			input.name = 'task';
      			input.value = 'create_shop';
      			input.type = 'hidden';

      			var flash = document.createElement('input');
      			flash.name = 'flash';
      			flash.value = flash_msg;
      			flash.type = 'hidden';

      			f.appendChild(input);
      			f.appendChild(flash);

      			document.getElementById('redirect').appendChild(f);
      			f.submit();	
      		}
      	}
      //]]>
      </script>
      <div id="redirect"></div>
      <?php
  	}
  	  	
  	function styles() { ?>
  	  <style type="text/css" media="screen">
        #popshops_wrap { font-family: arial; }
        
        iframe {
          width: 100%;
          height: 350px;
          border: none;
        }
        
        body #popshops_wrap a { 
          color: #3875D7; 
          font-weight: bold;
          font-size: 14px;
        }
        
        body #popshops_wrap h3 {
          font-size: 22px;
          font-family:arial;
        }
        
       #popshops_list_of_shops {
          border-collapse:collapse;
          width: 90%;
        }
        #popshops_list_of_shops th,
        #popshops_list_of_shops td {
          padding: 5px 5px 7px 5px;
          text-align: left;
        }
        th.left, th.center, th.right {
          background:#E5E5E5;
          border:1px solid #BBBBBB;
        }
        th.left {
          border-width:1px 0 1px 1px;
        }
        th.center {
          border-width:1px 0;
        }
        th.right {
          border-width:1px 1px 1px 0;
        }
        #popshops_list_of_shops td {
          border:1px solid #bbb;
          border-width:0 1px 1px 1px;
        }
        .alternate0 td { background: #F9F9F9;}
        .alternate1 td { background: #fff;}
      </style>
  	  <?php
  	}
  	
  }
?>