/* Import plugin specific language pack */
tinyMCE.importPluginLanguagePack('popshops');

var TinyMCE_PopShops = {
	getInfo : function() {
		return {
			longname : 'PopShops Quick Products',
			author : 'PopShops.com',
			authorurl : 'http://www.popshops.com',
			infourl : 'http://www.popshops.com/plugins/wordpress',
			version : tinyMCE.majorVersion + "." + tinyMCE.minorVersion
		};
	},

	/**
	 * Returns the HTML code for a specific control or empty string if this plugin doesn't have that control.
	 * A control can be a button, select list or any other HTML item to present in the TinyMCE user interface.
	 * The variable {$editor_id} will be replaced with the current editor instance id and {$pluginurl} will be replaced
	 * with the URL of the plugin. Language variables such as {$lang_somekey} will also be replaced with contents from
	 * the language packs.
	 *
	 * @param {string} cn Editor control/button name to get HTML for.
	 * @return HTML code for a specific control or empty string.
	 * @type string
	 */
	getControlHTML : function(cn) {
		switch (cn) {
			case "popshops":
				return tinyMCE.getButtonHTML(cn, 'lang_popshops_product', '{$pluginurl}/../../images/popshops.gif', 'popshops_browser');
		}

		return "";
	},

	/**
	 * Executes a specific command, this function handles plugin commands.
	 *
	 * @param {string} editor_id TinyMCE editor instance id that issued the command.
	 * @param {HTMLElement} element Body or root element for the editor instance.
	 * @param {string} command Command name to be executed.
	 * @param {string} user_interface True/false if a user interface should be presented.
	 * @param {mixed} value Custom value argument, can be anything.
	 * @return true/false if the command was executed by this plugin or not.
	 * @type
	 */
	execCommand : function(editor_id, element, command, user_interface, value) {
		// Handle commands
		switch (command) {
			// Remember to have the "mce" prefix for commands so they don't intersect with built in ones in the browser.
			case "popshops_browser":
				// Do your custom command logic here.
        PopShopsBrowser.launch();
				return true;
		}

		// Pass to next handler in chain
		return false;
	}
}

// Adds the plugin class to the list of available TinyMCE plugins
tinyMCE.addPlugin("popshops", TinyMCE_PopShops);